<template>
    <div id="graphiql">Loading...</div>
</template>

<script lang="ts" setup>
    import { onMounted, onUnmounted } from "vue";
    import useAppStore from "./../stores/app";
    import { getBearer } from "./../functions/bearer-auth";
    import { baseURL } from "./../functions/env";
    import React from "react";
    import { createRoot } from "react-dom/client";
    import { GraphiQL } from "graphiql";
    import { explorerPlugin } from "@graphiql/plugin-explorer";
    import { createGraphiQLFetcher } from "@graphiql/toolkit";

    const appStore = useAppStore();
    let root = null as any;

    appStore.$subscribe((_mutation, _state) => {
        rerender();
    });

    onMounted(() => {
        root = createRoot(document.getElementById("graphiql") as any);
        rerender();
    });

    onUnmounted(() => {
        root.unmount();
    });

    async function rerender() {
        const fetcher = createGraphiQLFetcher({
            url: `${baseURL()}graphql`,
            headers: { Authorization: `Bearer ${await getBearer()}` },
        });
        const explorer = explorerPlugin({ showAttribution: false });

        function MyComponent() {
            React.useEffect(() => {
                // Component has rendered
                if (appStore.darkMode) {
                    document.body.classList.add("graphiql-dark");
                    document.body.classList.remove("graphiql-light");
                } else {
                    document.body.classList.add("graphiql-light");
                    document.body.classList.remove("graphiql-dark");
                }
            }, []);

            // Define your GraphiQL element here
            const graphiqlElement = React.createElement(GraphiQL as any, {
                fetcher,
                defaultEditorToolsVisibility: true,
                // defaultHeaders: `{"asdasd": "asdasd"}`,
                plugins: [explorer],
            });

            return graphiqlElement;
        }

        root.render(React.createElement(MyComponent));
    }
</script>

<style scoped>
    #graphiql {
        height: 100vh;
    }
</style>
